/**
 * Die Grafik
 *
 *      1/3
 *       0  --> 1/2
 *               0 --> 1
 *                     0
 *
 * zeigt eine einfach verkettete Liste bestehend aus drei Listenelementen, von denen jedes genau zwei verschiedene Werte enhält.
 *
 * a) Definieren Sie im beigefügten Programm durch die Klasse Node jeden Knoten für diese einfach verkettete Liste folgendermassen:
 * 1. Objektvariable: Datentyp double, Name = filter_konstante
 * 2. Objektvariable: Datentyp Integer, Name = anz_kugeln
 * 3. Objektvariable: Datentyp Node, Name = next
 * (=Referenzvariable die auf den Nachfolger zeigt).
 *
 * Definieren Sie auch einen Konstruktor für die Klasse Node, der es erlaubt obige Liste Schritt für Schritt erzeugen.
 *
 * b) Erstellen Sie obige Liste mithilfe von Objekten der Klasse Node in der main Methode. Diese Konstruktion kann händisch oder mithilfe geeigneter Methoden
 *    erfolgen. Die Referenzvariable für den Listenkopf haben den Namen head.
 *    Bei diesem und den folgenden Punkten können Sie die bestehende Methode printList verwenden, um die gesamte Liste am Bildschirm anzuzeigen.
 *
 * c) Das gesamte Programm simuliert Kugeln, welche jeweils beim Kopf der Liste beginnend die Liste durchlaufen, und schliesslich bei einem der
 *    drei Knoten landet. Compilieren und testen Sie kurz das entsprechende Programm.
 *
 * d) Schreiben Sie eine Methode die es mittels Aufrufs
 *    head = deleteNode(head,nummer_des_knoten);
 *    allgemein erlaubt den nummer_des_knoten-ten Knoten aus einer deraritgen Liste herauszulöschen. nummer_des_knoten kann einen Wert von 1 bis zur Anzahl
 *    der Knoten in der Liste annehmen.
 *
 * e) Verwenden Sie die Methode deleteNode von Punkt d, um den zweiten Knoten von der Liste zu entfernen. Welche Auswirkungen hat das auf das bestehende
 *    Programm? Betrachten Sie ein paar Testläufe
 *
 *
 */
public class AdHoc7 {


    // *******************************************************************
    // Punkt a: Ihre Definition der Objektvariablen und des Konstruktors *
    // *******************************************************************

    public static int kugellauf(Node no) {
        int knoten_nummer = 1;
        int return_value = -1;
        boolean fertig = false;

        while (no != null && !fertig) {
            if (Math.random() < no.filter_konstante) {
                no.anz_kugeln++;
                return_value = knoten_nummer;
                fertig = true;
            }
            else {
                no = no.next;
                knoten_nummer++;
            }
        }

        return return_value;
    }

    public static void printAnzKugeln(Node no, int knoten_nummer_local, int zaehler) {
        if (no != null) {
            // System.out.println(no.filter_konstante);
            // System.out.println(no.anz_kugeln);

            if (no.anz_kugeln > 0) {
                for (int i = 1; i <= no.anz_kugeln - 1; i++) {
                    System.out.print("O");
                }

                if (knoten_nummer_local == zaehler) {
                    System.out.print("*");
                }
                else {
                    System.out.print("O");
                }
            }

            for (int i = 1; i <= 20 - no.anz_kugeln; i++) {
                System.out.print(" ");
            }

            printAnzKugeln(no.next, knoten_nummer_local, zaehler + 1);
        }
        else {
            System.out.println();
        }
    }

    public static void printList(Node no) {
        System.out.println("Ausgabe der Liste: ");
        int knoten_zaehler = 1;

        while (no != null) {
            System.out.println("Knoten Nummer " + knoten_zaehler++);
            System.out.println("filter_konstante = " + no.filter_konstante);
            System.out.println("anz_kugeln = " + no.anz_kugeln);
            System.out.println();

            no = no.next;
        }
    }

    // *******************************************
    // Punkt d: Erstellen der Methode deleteNode *
    // *******************************************

    public static void main(String[] args) {

        // ******************************
        // Punkt b: Erstellen der Liste *
        // ******************************

        System.out.println("---------------------");

        // printList(head);

        // ******************************************
        // Punkt e: Anwenden der Methode deleteNode *
        // ******************************************
        // head = deleteNode(head, 2);

        // printList(head);

        for (int i = 1; i <= 20; i++) {
            int knoten_nummer = kugellauf(head);
            printAnzKugeln(head, knoten_nummer, 1);

            // Warte eine Zehntelsekunde lang.
            long expectedtime = System.currentTimeMillis() + 100;

            while (System.currentTimeMillis() < expectedtime) {
                // Leere Schleife
            }
        }
    }
}

