/**
 * Der Flughafen Mistelbach (mit einer Rollbahn der Länge 2500m) verwaltet alle Fluggeräte mit einem Java-Programm.
 *
 * Schreiben Sie ein Interface Aircraft, welches einige grundlegende Eigenschaften eines Fluggeräts definiert, wie name, maxNumberOfPassengers, weight (in Tonnen)
 *
 * Schreiben Sie eine Klasse Helicopter, welche das Interface Aircraft implementiert. Implementieren Sie auch eine sinnvolle toString Methode.
 *
 * Schreiben Sie eine Klasse Airplane, welche das Interface Aircraft implementiert. Weiters hat die Klasse Airplane noch eine Methode neededRunwayLength, welche die benötigte Länge der
 * Rollbahn errechnet (Länge = weight(in Tonnen)*40m + numberOfPassenger *5m). Implementieren Sie auch eine sinvolle toString Methode.
 *
 * Schreiben Sie eine Klasse FleetManager, die eine Menge von Aircrafts verwalten kann. Die Klasse hat mehrere Methoden. addHelicopter(..), addAirplane(..),.... Die Methode allowedInMistelbach(..)
 * gibt aus, ob ein vollbesetztes Flugzeug in Mistelbach(auf Grund der vorhandenen/benötigten Länge der Rollbahn) starten/landen darf. Die Methode allowedInMistelbachForMaintenance(..) gibt aus,
 * ob ein leeres Flugzeug in Mistelbach (zur Wartung) starten landen darf. Implementieren Sie auch eine sinnvolle toString Methode.
 *
 * Zusatzfrage: Kann man auch ein allgemeines addAircraft(..) verwenden?
 *
 * Daten (Name, maxNumberofPassenger, weight):
 *
 * Flugzeuge:
 * Augustus, 200, 60
 * Bertus, 100, 40
 * Cirrus, 50, 20
 *
 * Hubschrauber:
 * Zanda, 5,7
 * Yippa, 4,5
 * Xena, 30,30
 */

import java.util.ArrayList;
public class AdHoc2 {

}


//eventuelle Lösung

/*
public interface Aircraft {
    String getName();
    int getMaxNumberOfPassengers();
    int getWeight();

}

/////////////////////////////////////////////////////////////////

public class Helicopter implements Aircraft {
    private String name;
    private int maxNumberOfPassengers, weight;

    Helicopter(String name, int maxNumberOfPassengers, int weight) {
        this.name = name;
        this.maxNumberOfPassengers = maxNumberOfPassengers;
        this.weight = weight;
    }

    @Override
    public String getName() {
        return this.name;
    }

    @Override
    public int getMaxNumberOfPassengers() {
        return this.maxNumberOfPassengers;
    }

    @Override
    public int getWeight() {
        return this.weight;
    }

    @Override
    public String toString() {
        return "(" + this.getClass().getName() + ") " + this.name + ", " + this.maxNumberOfPassengers + ", " + this.weight;
    }
}

/////////////////////////////////////////////////////////////////////

public class Airplane implements Aircraft {
    private String name;
    private int maxNumberOfPassengers;
    private int weight;

    Airplane (String name, int maxNumberOfPassengers, int weight) {
        this.name = name;
        this.maxNumberOfPassengers = maxNumberOfPassengers;
        this.weight = weight;
    }

    public int neededRunwayLength(int numberOfPassengers) {
        return this.weight * 40 + numberOfPassengers * 5;
    }


    @Override
    public String getName() {
        return this.name;
    }

    @Override
    public int getMaxNumberOfPassengers() {
        return this.maxNumberOfPassengers;
    }

    @Override
    public int getWeight() {
        return this.weight;
    }

    @Override
    public String toString() {
        return "(" + this.getClass().getName() + ") " + this.name + ", " + this.maxNumberOfPassengers + ", " + this.weight;
    }
}

/////////////////////////////////////////////////////////////////



public class Fleetmanager {
    final int runwayMistelbach = 2500;

    ArrayList<Aircraft> list = new ArrayList<Aircraft>();

    public void addHelicopter(String name, int maxNumberOfPassengers, int weight) {
        this.list.add(new Helicopter(name, maxNumberOfPassengers, weight));
    }
    // alternative
    public void addHelicopter(Helicopter h) {
        this.list.add(h);
    }

    public void addAirplane(String name, int maxNumberOfPassengers, int weight) {
        this.list.add(new Airplane(name, maxNumberOfPassengers, weight));
    }
    // alternative
    public void addAirplane(Airplane a) {
        this.list.add(a);
    }

    public boolean allowedInMistelbach(Airplane a) {
        return a.neededRunwayLength(a.getMaxNumberOfPassengers()) <= runwayMistelbach;
    }

    public boolean allowedInMistelbachForMaintenance(Airplane a) {
        return a.neededRunwayLength(0) <= runwayMistelbach;
    }

    public String toString() {
        String result = "";
        for (Aircraft val : list) {
            result += val + "\n";
        }
        return result;
    }

    public static void main(String[] args) {
        // for testing
        Fleetmanager fm = new Fleetmanager();

        fm.addAirplane("Augustus", 200, 60);
        // alternative
        fm.addAirplane(new Airplane("Bertus", 100, 40));
        fm.addAirplane("Cirrus", 50, 20);

        fm.addHelicopter("Zanda", 5, 4);
        fm.addHelicopter(new Helicopter("Yippa", 4, 5));
        fm.addHelicopter("Xena", 30, 30);

        System.out.println("Fluggeraete in Mistelbach:");
        System.out.println(fm);

        for (Aircraft val : fm.list) {
            if (val.getClass().getName().equals("Airplane")) {
                System.out.println(val.getName() + " is allowed to start/land in Mistelbach:    " + fm.allowedInMistelbach((Airplane) val));
                System.out.println(val.getName() + " is allowed to be maintained in Mistelbach: " + fm.allowedInMistelbachForMaintenance((Airplane) val));
                System.out.println();
            }
        }
    }

}



 */